// Direct3DɕKvȃwb_[ƃCu

#define D3D_DEBUG_INFO	// Direct3DfobNtO

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
#pragma comment(lib, "d3dxof.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "winmm.lib")
#include <comdef.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <mmsystem.h>

#include <Windows.h>
#include <tchar.h>

//////////////////////////////////////////////////////////////////////

// Direct3DNX
class Direct3D
{
public:
	IDirect3D9*				pD3D9;			// Direct3DfoCXpIuWFNg
	IDirect3DDevice9*		pDevice3D;		// Direct3D̃foCX

	// RXgN^
	Direct3D();
	// fXgN^
	~Direct3D();

	// foCX쐬
	bool Create(HWND hWnd,int Width,int Height);
};

// RXgN^
Direct3D::Direct3D(){
	pD3D9 = NULL;			// Direct3DfoCXpIuWFNg
	pDevice3D = NULL;		// Direct3D̃foCX
}
// fXgN^
Direct3D::~Direct3D(){
	// DirectX̕ϐ͕K㏈邱
	if(pDevice3D != NULL)
		pDevice3D->Release();
	if(pD3D9 != NULL)
		pD3D9->Release();
}

// foCX쐬
bool Direct3D::Create(HWND hWnd,int Width,int Height){
	
	// Direct3D9IuWFNg̍쐬	
	pD3D9 = Direct3DCreate9(D3D_SDK_VERSION);	
	// fBXvC擾
	D3DDISPLAYMODE Display;
	pD3D9->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &Display);

	D3DPRESENT_PARAMETERS	D3DParam = {			// Xbv`FCݒ
		Width,Height,Display.Format,1,D3DMULTISAMPLE_NONE,0,
		D3DSWAPEFFECT_DISCARD,hWnd,TRUE,TRUE,D3DFMT_D24S8,0,0,D3DPRESENT_INTERVAL_DEFAULT
	};			
	
	// HAL[h3DfoCX쐬
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL, D3DParam.hDeviceWindow,
		D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, D3DParam.hDeviceWindow, 
		D3DCREATE_MIXED_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	// REF[h3DfoCX쐬
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, D3DParam.hDeviceWindow, 
		D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, D3DParam.hDeviceWindow, 
		D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	{
		// 3DfoCX쐬s(̃OtBbN{[hłDirectXgȂ)
		pD3D9->Release();
		return false;
	}

	return true;
}

///////////////////////////////////////////////////////////////////

// eNX`NX
class Texture
{
public:
	IDirect3DTexture9* pTexture;
	// RXgN^
	Texture();
	// fXgN^
	~Texture();
	// 摜f[^ǂݍ
	bool Load(IDirect3DDevice9* pDevice3D,TCHAR* FileName);
};

Texture::Texture(){
	pTexture = NULL;
}
Texture::~Texture()
{
	// ǂݍ܂Ăj
	if(pTexture != NULL)
		pTexture->Release();
}
bool Texture::Load(IDirect3DDevice9* pDevice3D,TCHAR* FileName)
{
	// 摜ǂݍ
	// DirextXWindowsAPI̊֐HRESULTʂɕԂ֐
	// FAILED}NŊ֐s킩
	// SUCEEDED}NŊ֐킩
	if(FAILED(D3DXCreateTextureFromFile(pDevice3D,FileName,&pTexture)))
		return false;	// 摜ǂݍݎsit@CȂ\j

	// 摜ǂݍݐ
	return true;
}

//////////////////////////////////////////////////////////////////////

// XvCgNXi2D|Sj
class Sprite
{
public:
	// |S_
	struct Vertex{
		float x,y,z;// 3W
		float rhw;	// 2Dϊς݃tO
		float u,v;	// UVW
	};
	// FVFi_Ȓ_\̐錾jtO
	static const DWORD SPRITE_FVF = D3DFVF_XYZRHW | D3DFVF_TEX1;
	
	// XvCgʒu
	D3DXVECTOR2 pos;
	// XvCgTCY
	int width;
	int height;

	// RXgN^
	Sprite();
	// fXgN^
	~Sprite();

	void SetPos(float x,float y);
	void SetWidth(int Width,int Height);
	void Draw(IDirect3DDevice9* pDevice3D,IDirect3DTexture9* pTexture);

};

// RXgN^
Sprite::Sprite()
{
	pos.x = pos.y = 0.0f;
	width = 0;
	height = 0;
}
// fXgN^
Sprite::~Sprite(){}

void Sprite::SetPos(float x,float y)
{
	pos.x = x;
	pos.y = y;
}
void Sprite::SetWidth(int Width,int Height)
{
	width = Width;
	height = Height;
}

void Sprite::Draw(IDirect3DDevice9* pDevice3D,IDirect3DTexture9* pTexture)
{
	// _Zbg
	Vertex vtx[4]={
		{ pos.x + width/2, pos.y - height/2, 0.0f, 1.0f, 1.0f, 0.0f},
		{ pos.x + width/2, pos.y + height/2, 0.0f, 1.0f, 1.0f, 1.0f}, 
		{ pos.x - width/2, pos.y - height/2, 0.0f, 1.0f, 0.0f, 0.0f}, 
		{ pos.x - width/2, pos.y + height/2, 0.0f, 1.0f, 0.0f, 1.0f} 
	};

	// eNX`Zbg
	pDevice3D->SetTexture(0,pTexture);
	// _\̐錾Zbg
	pDevice3D->SetFVF(SPRITE_FVF);
	// XvCg`
	pDevice3D->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,vtx,sizeof(Vertex));
}

//////////////////////////////////////////////////////////////////////

// EBhEvV[WAEBhEɑ΂郁bZ[Ws
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	
	switch(msg){
		// EBhEjꂽƂ
	case WM_DESTROY:
		PostQuitMessage(0);	// WM_QUITbZ[WbZ[WL[ɑ
		return 0;
	}
	// ftHg̃bZ[Ws
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

// WinMain֐iAvP[V̊Jn֐j
// R\[AvP[VƈႢAR\[JȂ
int _stdcall WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	const TCHAR* WC_BASIC = _T("BASIC_WINDOW");
	// VvEBhENXݒ
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS,WndProc, 0,0,hInstance,
		(HICON)LoadImage(NULL,MAKEINTRESOURCE(IDI_APPLICATION),IMAGE_ICON,0,0,LR_DEFAULTSIZE | LR_SHARED),
		(HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED), 
		(HBRUSH)GetStockObject(WHITE_BRUSH), NULL, WC_BASIC , NULL};

	// VvEBhENX쐬
	if(!RegisterClassEx(&wcex)) 
		return false;

	// EBhEA̓fBXvCɈˑBʂ4:3
	const int WINDOW_WIDTH = 640;
	const int WINDOW_HEIGHT = 480;
	// EBhE̍쐬
	HWND hWnd = CreateWindowEx(0,WC_BASIC,
		_T("Application"), WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,WINDOW_WIDTH,WINDOW_HEIGHT,NULL,NULL,hInstance,NULL);

///////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////
	//	Direct3D̏
	////////////////////////////////////
	Direct3D direct3d;
	direct3d.Create(hWnd,WINDOW_WIDTH,WINDOW_HEIGHT);

	////////////////////////////////
	// eNX`쐬
	////////////////////////////////
	Texture cartex;
	cartex.Load(direct3d.pDevice3D,_T("car.bmp"));

	////////////////////////////////
	// XvCg쐬
	////////////////////////////////
	Sprite sprite[2];

	sprite[0].SetPos(100,100);
	sprite[0].SetWidth(128,128);
	sprite[1].SetPos(300,300);
	sprite[1].SetWidth(128,128);
	
///////////////////////////////////////////////////////////////////////////////////////////////
		
	// bZ[W[v
	MSG msg = {}; 
	while(msg.message != WM_QUIT) {
		// AvP[VɑĂ郁bZ[WbZ[WL[擾
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			DispatchMessage(&msg);	// AvP[V̊eEBhEvV[WɃbZ[W]
		}
		// bZ[WĂȂƂ
		else{
			//iDirectX̏j

///////////////////////////////////////////////////////////////////////////////////////////////

			// `Jn
			if(SUCCEEDED(direct3d.pDevice3D->BeginScene()))
			{
				DWORD ClearColor = 0xff808080;	// wiNAF
				// wiNA
				direct3d.pDevice3D->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_STENCIL | D3DCLEAR_ZBUFFER, ClearColor, 1.0f, 0 );

				
				// XvCg`
				for(int i = 0;i < 2;++i){
					sprite[i].Draw(direct3d.pDevice3D,cartex.pTexture);
				}

				// `I
				direct3d.pDevice3D->EndScene();
			}
			// `攽f
			direct3d.pDevice3D->Present( NULL, NULL, NULL, NULL );

///////////////////////////////////////////////////////////////////////////////////////////////
		}
	}

	
	return 0;
}